var isInit = false;
var isUpdate = false;
var updateStr = '';
var jsonStr = '';
//平台类型 android \ios
var platformType="";
var API;
/**
 * HashMap构造函数
 */
function JHashMap() {
	this.length = 0;
	this.prefix = "hashmap_prefix_20040716_";
}

/**
 * 向HashMap中添加键值对
 */
JHashMap.prototype.put = function(key, value) {
	this[this.prefix + key] = value;
	this.length++;
}
/**
 * 从HashMap中获取value值
 */
JHashMap.prototype.get = function(key) {
	return typeof this[this.prefix + key] == "undefined" ? null
			: this[this.prefix + key];
}
/**
 * 从HashMap中获取所有key的集合，以数组形式返回
 */
JHashMap.prototype.keySet = function() {
	var arrKeySet = new Array();
	var index = 0;
	for ( var strKey in this) {
		if (strKey.substring(0, this.prefix.length) == this.prefix)
			arrKeySet[index++] = strKey.substring(this.prefix.length);
	}
	return arrKeySet.length == 0 ? null : arrKeySet;
}
/**
 * 从HashMap中获取value的集合，以数组形式返回
 */
JHashMap.prototype.values = function() {
	var arrValues = new Array();
	var index = 0;
	for ( var strKey in this) {
		if (strKey.substring(0, this.prefix.length) == this.prefix)
			arrValues[index++] = this[strKey];
	}
	return arrValues.length == 0 ? null : arrValues;
}
/**
 * 获取HashMap的value值数量
 */
JHashMap.prototype.size = function() {
	return this.length;
}
/**
 * 删除指定的值
 */
JHashMap.prototype.remove = function(key) {
	delete this[this.prefix + key];
	this.length--;
}
/**
 * 清空HashMap
 */
JHashMap.prototype.clear = function() {
	for ( var strKey in this) {
		if (strKey.substring(0, this.prefix.length) == this.prefix)
			delete this[strKey];
	}
	this.length = 0;
}
/**
 * 判断HashMap是否为空
 */
JHashMap.prototype.isEmpty = function() {
	return this.length == 0;
}
/**
 * 判断HashMap是否存在某个key
 */
JHashMap.prototype.containsKey = function(key) {
	for ( var strKey in this) {
		if (strKey == this.prefix + key)
			return true;
	}
	return false;
}
/**
 * 判断HashMap是否存在某个value
 */
JHashMap.prototype.containsValue = function(value) {
	for ( var strKey in this) {
		if (this[strKey] == value)
			return true;
	}
	return false;
}
/**
 * 把一个HashMap的值加入到另一个HashMap中，参数必须是HashMap
 */
JHashMap.prototype.putAll = function(map) {
	if (map == null)
		return;
	if (map.constructor != JHashMap)
		return;
	var arrKey = map.keySet();
	var arrValue = map.values();
	for ( var i in arrKey)
		this.put(arrKey[i], arrValue[i]);
}
// toString
JHashMap.prototype.toString = function() {
	var str = "";
	for ( var strKey in this) {
		if (strKey.substring(0, this.prefix.length) == this.prefix)
			str += strKey.substring(this.prefix.length) + " : " + this[strKey]
					+ "\r\n";
	}
	return str;
}
String.prototype.replaceAll = function(s1, s2) {
	var temp = this;
	while (temp.indexOf(s1) != -1) {
		temp = temp.replace(s1, s2);
	}
	return temp;
}
/* GetParam Map */
var paraMap = new JHashMap();
/**
 * @remark 以下为课件初始化参数设置SET,GET方法
 */
var getAttemptStateData = "";
function setAttemptStateData(data){
		try{
			this.getAttemptStateData = "errorCode="+data.errorCode+"\n"+
		   "initialized="+data.initialized+"\n"+
		   "autoCommit="+data.autoCommit+"\n"+
		   "errorText="+data.errorText+"\n"+
		   "finished="+data.finished;
		 }catch(e){
		    console.log("setAttemptStateData数据异常："+e.message);
		}
}
var initializeData = "";
function setInitializeData(data){
	this.initializeData = "errorText="+data.errorText+"\n"+
						  "errorCode="+data.errorCode;
}
var getParamData = "";
function setParamData(data){
					 
					 try{
						 this.getParamData = "cmi.suspend_data="+data.cmi_suspend_data+"\n"+ 
				        "cmi.core.lesson_location="+data.cmi_core_lesson_location+"\n"+ 
				        "cmi.core.credit="+data.cmi_core_credit+"\n"+ 
				        "adl.nav.request_valid.continue="+data.adl_nav_request_valid_continue+"\n"+
				        "cmi.core.lesson_status="+data.cmi_core_lesson_status+"\n"+
				        "cmi.core.session_time="+data.cmi_core_session_time+"\n"+
				        "errorCode="+data.errorCode+"\n"+
				        "adl.nav.request_valid.previous="+data.adl_nav_request_valid_previous+"\n"+
				        "cmi.core.student_id="+data.cmi_core_student_id+"\n"+
				        "cmi.core.student_name="+data.cmi_core_student_name+"\n"+
				        "cmi.core.entry="+data.cmi_core_entry+"\n"+
				        "cmi.core.lesson_mode="+data.cmi_core_lesson_mode+"\n"+
				        "cmi.core.total_time="+data.cmi_core_total_time+"\n"+
				        "errorText="+data.errorText+"\n"+
				        "cmi.core.exit="+data.cmi_core_exit+"\n"+
				        "cmi.core.score.raw="+data.cmi_core_score_raw;
				     }catch(e){
			 		    console.log("setParamData数据异常："+e.message);
			 		 }
}


/**
 * @获得随机数
 */
function getMathNum(){
	return Math.floor(Math.random() * ( 1000 + 1));
}
 
 /**
 * @remark 获得课程课件提交的跟踪信息，在ScormAPI.js中updateServer方法中调用
 */ 
function updateLessonStudyInfo(info){
 
try{
	var infos = info.split("\n");
		isUpdate = true;
		updateStr = infos[0];
		console.log("获得课程课件提交的跟踪信息，updateStr:"+updateStr);
		var param = updateStr.split("=");
		var key = param[0].replaceAll(".", "_");
		var value = param[1];
		paraMap.put(key, value);
	}catch(e){
	 console.log("获得课程课件提交的跟踪信息异常："+e.message);	
	}
}
//获取学习状态
 function  getStatus(status){
 	if(status!==null&&!status!==""){
			if(status=="C"){
				 status = "complete";
			}else if(status=="completed"){
				status = "C";
			}else if(status=="complete"){
				status = "C";
			}else if(status=="P"){
				status = "passed";
			}else if(status=="passed"){
				status = "P";
			}else if(status=="I"){
				status = "incomplete";
			}else if(status=="incomplete"){
				status = "I";
			}else if(status=="F"){
				status = "failed";
			}else if(status=="failed"){
				status = "F";
			}else{
				status="incomplete";
			}
		}else{
			status="incomplete";
		}
		return status;
 }
// 获取要更新参数
function getUpdateParam() {
	
	var status=this.paraMap.get("cmi_core_lesson_status");
	if(status==""||status==null){
		status="incomplete";
	}
	 status=getStatus(status);
	var param = {
	 	lesson_status :status,
		grade : this.paraMap.get("cmi_core_score_raw"),
		lesson_location : this.paraMap.get("cmi_core_lesson_location"),
		suspend_data : this.paraMap.get("cmi_suspend_data") 
	};
	return JSON.stringify(param);
	
}

 //保存课程学习记录android 、ios
 function saveStudy() {
 		var param=getUpdateParam();
	 	if(platformType=="android"){
			// 调用android 原生程序保存
			javascript:android.saveStudy(param);
		}else if(platformType =="ios"){
			// 调用ios 原生程序保存
			window.location.href = "objc://saveStudy:/" + param;
		}
 }

//测试
function initDat(){
alert("agaag");
}

//初始化数据
 function initData(json){
 	 	if(!isInit){
 	 		isInit=true;
 			  try{
		 	 		var obj={"GetAttemptState":{"errorCode":"0","initialized":"false","autoCommit":"true","errorText":"","finished":"false"},"Initialize":{"errorText":"","errorCode":"0"},"GetParam":{"cmi_core_lesson_location":"","cmi_suspend_data":"","cmi_core_credit":"credit","adl_nav_request_valid.continue":"false","cmi_core_lesson_status":"","cmi_core_session_time":"","errorCode":"0","adl_nav_request_valid_previous":"false","cmi_core_student_id":"offlineUser","cmi_core_student_name":"offlineUser","cmi_core_entry":"","cmi_core_lesson_mode":"normal","cmi_core-total_time":"","errorText":"","cmi_core_exit":"suspend","cmi_core_score_raw":"-1000.0"}}; 
					if(json!==undefined &&json!==null&&json!==""){
							//转换状态字符串
						var status=getStatus(json.lesson_status); 
						this.paraMap.put("cmi_suspend_data", json.suspend_data);
						this.paraMap.put("cmi_core_lesson_status",status);
						this.paraMap.put("cmi_core_score_raw",json.grade);
						this.paraMap.put("cmi_core_lesson_location",json.lesson_location);
						//平台类型 android \ios
						platformType=json.type; 
						//跟踪信息
			 	 	 	obj.GetParam.cmi_suspend_data=json.suspend_data;
			 	 		//学习状态
			 	    	obj.GetParam.cmi_core_lesson_status=status;
				 	  	//学习成绩
				 	 	 obj.GetParam.cmi_core_score_raw=json.grade;
				 	 	  // 学习记录的位置
					  	obj.GetParam.cmi_core_lesson_location=json.lesson_location;
						//初始化课件信息
						this.setAttemptStateData(obj.GetAttemptState);
						this.setInitializeData(obj.Initialize);
						this.setParamData(obj.GetParam);
						if(this.getParamData!=null&&this.getParamData!=""){
							 API = new GenericAPIAdaptor;
							 var iframe=document.getElementById('iframeB');
							 //添加课件载入成功事件
							 if (iframe.attachEvent){ 
									iframe.attachEvent("onload", function(){ 
												 // 课件加载成功
									     if(platformType=="android"){
												 javascript:android.loaded();
									     	}else {
												 window.location.href = "objc://loaded:/";
									     	}
									}); 
								} else { 
									iframe.onload = function(){ 
								   			 // 课件加载成功
									     if(platformType=="android"){
												 javascript:android.onloaded();
									     	}else {
												 window.location.href = "objc://loaded:/";
									     	}
							    }; 
								} 
							 iframe.src =json.rco_url; 
							 console.log("初始化成功");
						}
						}else{
							alert("初始化数据失败，参数不能为空");
						}
			   }catch(e){
			 		console.log("初始化数据异常："+e.message);
			 	}
 	 	}
}